<?php 

/*
Plugin Name: EditorMonkey
Plugin URI: http://www.rajprasad.net/plugins/editormonkey/
Version: 2.5
Description: Turns the normal WordPress textarea into a WYSIWYG editor using TinyMCE or FCKeditor. Also integrates spell checking into the editor interface using the FCK Speller Pages plugin and ieSpell. Supports custom dictionaries.
Author: Raj Prasad
Author URI: http://www.rajprasad.net/
*/


/*
	TODO: 
	EM Version Tracker
		- Check my website to see if there is a newer version available
		- Store to database
		- Update script which will update database if the version # is too low
	Custom Toolbars
		-	All the FCK stuff to match what Tiny's got
*/


if ( !class_exists("editormonkey") ) {
class editormonkey {

	// PHP 5 constructor
	function __construct () {
	
		/*** UPGRADE/INSTALL **/
		$version = 250;
		if ( !get_option('editormonkey_version') ) {
			// -- Install -- //
			// The version check is king
			add_option('editormonkey_version',$version,'Version of installed EditorMonkey');
			
			// Add the default options for using EditorMonkey
			add_option('editormonkey_use', 'true', 'Automatically use the WYSIWYG interface');
			add_option('editormonkey_overrideusers', 'true', 'Force all users to use the plugin settings');
			add_option('editormonkey_disable_builtin', 'true', 'Automatically disable the built-in interface');
			add_option('editormonkey_interface', 'tinymce', 'The WYSIWYG interface to use when editing post or pages.');
			add_option('editormonkey_height', '250', 'Height, in pixels, of the WYSIWYG interface');
			add_option('editormonkey_lang', 'en', 'Dictionary to use for editor and spell checking');
			add_option('editormonkey_toolbar', 'WordPress', 'FCK toolbar buttons set');
			
			// File Browser settings
			add_option('editormonkey_upload',"true",'Allow uploading using the File Browser');
			
			
			add_option('editormonkey_upload_dir', str_replace(chr(92), '/',realpath(dirname(__FILE__).DIRECTORY_SEPARATOR.'..')).'/uploads/','Directory for File Browser uploads');
			add_option('editormonkey_upload_rel',"/wp-content/uploads/",'Directory for File Browser uploads');
			
			// Spell checking options
			add_option('editormonkey_aspell', 'aspell', 'Location of the aspell binary used for spell checking');
			add_option('editormonkey_spell','Jacuba','Spell checker to use.');
			add_option('editormonkey_spell_words',"WordPress\nEditorMonkey\nTinyMCE\nFCKeditor\nMozilla\nFirefox",'Personal dictionary words list.');
			
			// Miscellaneous Options
			add_option('editormonkey_custom_styles','.funkyblue { color:#0000AF; }','Custom CSS styles');
			
			// FCK options
			add_option('editormonkey_fck_skin', 'default', 'FCK graphical skin');
			add_option('editormonkey_fck_toolbar', 'WordPress', 'FCK toolbar');
			
			// TinyMCE options
			add_option('editormonkey_mce_compress', 'false', 'Use gzip-compressed TinyMCE');
			add_option('editormonkey_mce_resize', 'false', 'Allow the editing area to be resized.');
			add_option('editormonkey_mce_plugins',array('emotions','paste','advimage','advlink','advhr','searchreplace','spellcheck','wordpress'), 'Plugins to load for TinyMCE');
			add_option('editormonkey_mce_addparams', '', 'Additional parameters to pass to TinyMCE');
			add_option('editormonkey_mce_valid_elements', "-a[id|href|title|rel|target],\n-strong/b,-em/i,-strike,-del,-u,-sub,-sup,font[face|color],\n-ol,-ul,-li,br,\np[class|align|dir],-blockquote[dir],\n-div[dir|class|align],-span[class|align],\nimg[class|src|alt|title|width|height|align],\n-table[border|cellspacing|cellpadding|width|height|class|align|dir],\ntr[class|rowspan|width|height|align|valign|dir],\ntd[dir|class|colspan|rowspan|width|height|align|valign],\n-h1[class|align|dir],-h2[class|align|dir],-h3[class|align|dir],\n-h4[class|align|dir],-h5[class|align|dir],-h6[class|align|dir],\n-pre[class],-code[class],-address,hr[class|width|size|noshade]", 'Default valid elements in TinyMCE');
			
			// TinyMce Toolbars
			add_option('editormonkey_mce_toolbars', 'WordPress1,WordPress2,WordPress3', 'MCE Toolbars');
			add_option('editormonkey_mce_toolbars_data', 
				array('Basic' => 'bold,italic,underline,separator,numlist,bullist,separator,link,unlink,separator,emotions,separator,undo,redo,spellcheck', 
					'Simple' => 'bold,italic,underline,separator,more,nextpage,separator,numlist,bullist,separator,link,unlink,separator,image,emotions,separator,undo,redo,spellcheck',
					'Comments' => 'bold,italic,underline,separator,numlist,bullist,separator,emotions,separator,undo,redo,spellcheck',
					'WordPress1' => 'undo,redo,separator,selectall,cut,copy,paste,separator,pastetext,pasteword,separator,search,replace,separator,code,cleanup,separator,visualaid,fullscreen,separator,help,spellcheck',
					'WordPress2' => 'link,unlink,anchor,separator,image,flash,separator,more,nextpage,separator,advhr,charmap,emotions',
					'WordPress3' => 'formatselect,separator,fontsizeselect,separator,bold,italic,underline,strikethrough,sub,sup,separator,justifyleft,justifyright,justifycenter,justifyfull,separator,bullist,numlist,indent,outdent,separator,forecolor,backcolor,separator,removeformat' 
				),
	
				'MCE Toolbars');
		
			// Styles Editor (editor css, content css)
			add_option('editormonkey_mce_css_editor', 'false', 'Custom Editor CSS');
			add_option('editormonkey_mce_css_content', 'false', 'Custom Content Area CSS');
			
			// Comment form options
			add_option('editormonkey_comm','false','Use WYSIWYG interface in comments form?');
			add_option('editormonkey_comm_size','200','Size of the editing area in the comments form');
			add_option('editormonkey_comm_if','fckeditor','WYSIWYG interface to use in comments form');
			add_option('editormonkey_comm_tb', 'Comments', 'Toolbar buttons set for comments form');
			add_option('editormonkey_comm_fck_skin', 'default', 'FCK graphical skin for comments form');
		
			// Make sure to set the permissions on the EditorMonkey directories
			error_reporting( 0 ) ;
			em_set_perms(dirname(__FILE__).DIRECTORY_SEPARATOR.'editormonkey'.DIRECTORY_SEPARATOR);
			ini_restore( 'error_reporting' ) ;
		}
		elseif ( 242 > get_option('editormonkey_version') ) {
			// -- UPGRADE -- //
			// Add only the options new since the last upgrade
			update_option('editormonkey_version', $version);
		}
		
		/*** HOOKS **/
		// Plugin hook to the OPTIONS menu
		add_action('admin_menu',   array(&$this, 'admin_menu'));
		
		// Add actions to the various WP editing forms		
		add_action('admin_head',array('editormonkey', 'insert_interface'));
		add_action('edit_form_advanced',array('editormonkey', 'load_interface'));
		add_action('edit_page_form',array('editormonkey', 'load_interface'));
		add_action('simple_edit_form',array('editormonkey', 'load_interface'));

		// Add actions to the comment form
		add_action('wp_head', array('editormonkey', 'insert_comment_interface'));	
		add_action('wp_head', array('editormonkey', 'insert_custom_styles_css'));	
		add_action('comment_form',array('editormonkey', 'load_comment_interface'));
		
		// Add actions to Profile page so people can choose between interface options
		add_action('profile_personal_options',array('editormonkey','user_personalopts'));
		add_action('personal_options_update',array('editormonkey','user_personalopts_update'));
		
		// If the admin has chosen to disable WP from loading the built-in editor in EditorMonkey
		// plugin page, but enabled WP to do so from the Options>Writing page, disable it so that
		// it doesn't interfere with EditorMonkey
		if (get_option('editormonkey_disable_builtin') == 'true')
			update_option('rich_editing', 'false');
		
		
		/*** CHECKS **/
		error_reporting( 0 ) ;
		// Fiddle with the upload directory
		$uploaddir = get_option('editormonkey_upload_dir');
		if ( substr($uploaddir, strlen($uploaddir)-1) == '/' ) { 
			$uploaddir = substr($uploaddir, 0, -1);
		}			
		if ( is_dir( $uploaddir ) ) {
			$oldumask = umask(0) ;
			chmod( $uploaddir, 0777 ) ;
			umask( $oldumask ) ;
		}
		else {
			mkdir($uploaddir, 0777);
		}
		
		// If this is the plugins page, show the plugin options
		if (is_plugin_page()) {
			editormonkey::plugin_panel();
		}
	}
	
	
	// PHP 4 Constructor
	function editormonkey ()
	{
		$this->__construct() ;
	}
	
	function admin_menu () {
		if (function_exists('add_options_page')) {
			add_options_page('EditorMonkey', 'EditorMonkey', 8, basename(__FILE__));
		}
	}
	
	
	/**
		Creates a personal dictionary, 0=plugin/global dictionary
	*/
	function create_dictionary ( $userid = 0 ) {
		// Don't do anything if not using server-side aspell
		if( get_option('editormonkey_spell') != 'SpellerPages' )
			return;
			
		// retrieve wordlist and language depending on user id...
		if ( $userid == 0 ) {
			$wordlist = get_option('editormonkey_spell_words');
			$dictlang = get_option('editormonkey_lang');
		} else {
			$wordlist = get_user_option('em_user_spell_words');
			$dictlang = get_user_option('em_user_lang');
		}
		$dictwords = explode("\n", $wordlist);
		$dictsize = count($dictwords);
		
		// Open the file in binary write mode
		$sep = DIRECTORY_SEPARATOR;
		$dict = fopen ( dirname(__FILE__).$sep.'editormonkey'.$sep.'dictionaries'.$sep."dict_$userid", 'wb' );
		
		// Personal dictionary header, including version, language, and # of words
		@fwrite ($dict, "personal_ws-1.1 $dictlang $dictsize\n");
		
		// Write the words, baby
		foreach( $dictwords as $word ) {
			@fwrite( $dict, trim($word) . "\n" );
		}
		@fclose ($dict);
	}
	

	/**
		Inserts javascript for the interfaces
	*/
	function insert_interface () {
		global $current_user,  $action;
		
		// Comment form in Admin mode
		if (($action=='editcomment') && (get_option('editormonkey_overrideusers') == 'true')) {
			add_action('admin_footer',array('editormonkey', 'load_interface'));
		}
			
		// Check to make sure users prefs are set in case they are needed
		if(get_user_option('em_user_userprefset') != 'true') {
			update_user_option( $current_user->id, 'em_user_userprefset', 'true', true);
			
			update_user_option( $current_user->id, 'em_user_use', get_option('editormonkey_use'), true);
			update_user_option( $current_user->id, 'em_user_height', get_option('editormonkey_height'), true);
			update_user_option( $current_user->id, 'em_user_lang', get_option('editormonkey_lang'), true);
			update_user_option( $current_user->id, 'em_user_interface', get_option('editormonkey_interface'), true);
			update_user_option( $current_user->id, 'em_user_toolbar', get_option('editormonkey_toolbar'), true);
			update_user_option( $current_user->id, 'em_user_fck_skin', get_option('editormonkey_fck_skin'), true);
			update_user_option( $current_user->id, 'em_user_spell_words', get_option('editormonkey_spell_words'), true);
		}
		
		// Retrieve the options from plugin or user as appropriate
		if ( get_option('editormonkey_overrideusers') == 'true' ) {
			$em_use = get_option('editormonkey_use');
			$em_interface = get_option('editormonkey_interface');
		} else {
			$em_use = get_user_option('em_user_use');
			$em_interface = get_user_option('em_user_interface');
		} 
		
		// Disable built-in editor if we are using EditorMonkey
		if ($em_use == 'true')
			update_user_option( $current_user->id, 'rich_editing', 'false', true);
		
		?>
		<style type="text/css">
				/* hide the quick tags */
				#quicktags { display: none; }
				
				/* toggle dbx images */
				a.dbx-toggle, a.dbx-toggle:visited {
					display:block;
					overflow: hidden;
					background-image: url( images/toggle.gif );
					position: absolute;
					top: 0px;
					right: 0px;
					background-repeat: no-repeat;
					border: 0px;
					margin: 0px;
					padding: 0px;
				}
								
				a.dbx-toggle, #moremeta a.dbx-toggle-open:visited {
					height: 25px;
					width: 27px;
					background-position: 0 0px;
				}
				
				a.dbx-toggle-open, #moremeta a.dbx-toggle-open:visited {
					height: 25px;
					width: 27px;
					background-position: 0 -25px;
				}
				
				#grabit {
					width: 100%;
				}
				
				
			</style>
		<?php
		
		if ( $em_use == 'true' ) {
			switch ($em_interface) {
			case 'tinymce' :
				editormonkey::insert_TinyMCE();
				break;
			case 'fckeditor' :
				// fall through to default
			default :
				editormonkey::insert_FCKeditor();
				break;
			}
			?>
			
			<script type="text/javascript" src="../wp-includes/js/dbx.js"></script>
			<script type="text/javascript" >
				var em_manager = new dbxManager('editormonkey');
			</script>
			<script type="text/javascript" >
			addLoadEvent( function() {
				var emmeta = new dbxGroup(
					'emgrabit', 	// container ID [/-_a-zA-Z0-9/]
					'vertical', 	// orientation ['vertical'|'horizontal']
					'10', 			// drag threshold ['n' pixels]
					'yes',			// restrict drag movement to container axis ['yes'|'no']
					'10', 			// animate re-ordering [frames per transition, or '0' for no effect]
					'yes', 			// include open/close toggle buttons ['yes'|'no']
					'closed', 		// default state ['open'|'closed']
					'open', 		// word for "open", as in "open this box"
					'close', 		// word for "close", as in "close this box"
					'click-down and drag to move this box', // sentence for "move this box" by mouse
					'click to %toggle% this box', // pattern-match sentence for "(open|close) this box" by mouse
					'use the arrow keys to move this box', // sentence for "move this box" by keyboard
					', or press the enter key to %toggle% it',  // pattern-match sentence-fragment for "(open|close) this box" by keyboard
					'%mytitle%  [%dbxtitle%]' // pattern-match syntax for title-attribute conflicts
					);
				});
			</script>
			
			<?php
		}
	}
		
		
	/**
		Includes the custom css styles
	*/
	function insert_custom_styles_css() {
		echo "\n<style type='text/css'/>\n";
		echo stripslashes(get_option('editormonkey_custom_styles'));
		echo "\n</style>\n";
	}
	
	
	/**
		Inserts the appropriate interface for the comment form into the header
	*/
	function insert_comment_interface() {	
		if (get_option('editormonkey_comm') == 'true') { 		
			$em_interface = get_option('editormonkey_comm_if');
			switch ($em_interface) {
			case 'tinymce' :
				editormonkey::insert_TinyMCE();
				break;
			case 'fckeditor' :
				// Fall through to default
			default :
				editormonkey::insert_FCKeditor();
				break;
			}
		}
	}
	
	/**
		Helper functions to reduce clutter in the bigger functions and reduce # of times
		I repeat code that might have to be changed later
	*/
	function insert_FCKeditor() {
		?><script type="text/javascript" src="<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/fckeditor/fckeditor.js"></script><?php
	}
	function insert_TinyMCE() {
		if ( get_option('editormonkey_mce_compress')  == 'true' ) {
		?><script type="text/javascript" src="<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/tinymce/tiny_mce_gzip.php"></script><?php
		} else {
		?><script type="text/javascript" src="<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/tinymce/tiny_mce.js"></script><?php
		}
	}
	
	
	/**
		Calls the interface-specific loading function
	*/
	function load_interface () {
		if ( get_option('editormonkey_overrideusers') == 'true' ) {
			$em_use = get_option('editormonkey_use');
			$em_interface = get_option('editormonkey_interface');
			$em_height = get_option('editormonkey_height');
			$em_lang = get_option('editormonkey_lang');
			$em_spellcheck = get_option('editormonkey_spell');
			$em_toolbar = get_option('editormonkey_toolbar');
			$em_skin = get_option('editormonkey_fck_skin');
		} else {
			$em_use = get_user_option('em_user_use');
			$em_interface = get_user_option('em_user_interface');
			$em_height = get_user_option('em_user_height');
			$em_lang = get_user_option('em_user_lang');
			$em_toolbar = get_user_option('em_user_toolbar');
			$em_skin = get_user_option('em_user_fck_skin');
		}
		
		$em_spellcheck = get_option('editormonkey_spell');
		$em_upload = get_option('editormonkey_upload');
	
		if ($em_use == 'true') { 
			switch ($em_interface) {
			case 'tinymce' :
				editormonkey::load_TinyMCE('content', $em_height, $em_lang, $em_toolbar, $em_spellcheck, $em_upload);
				break;
			case 'fckeditor' :
				// fall through to default
			default :
				editormonkey::load_FCKeditor( 'content', $em_height, $em_lang, $em_toolbar, $em_skin, $em_spellcheck, $em_upload);
				break;
			}
		}
	}
	
	
	/**
		Loads the appropriate interface for the comment form
	*/
	function load_comment_interface( ) {
		if (get_option('editormonkey_comm') == 'true') {

			$em_lang = get_option('editormonkey_lang');
			$em_spellcheck = get_option('editormonkey_spell');
			$em_interface = get_option('editormonkey_comm_if');
			$em_height = get_option('editormonkey_comm_size');
			$em_toolbar = get_option('editormonkey_comm_tb');
			$em_skin = get_option('editormonkey_comm_fck_skin');
			
			switch ($em_interface) {
				case 'tinymce' :
					editormonkey::load_TinyMCE('comment', $em_height, $em_lang, $em_toolbar, $em_spellcheck, false );
					break;
				case 'fckeditor' :
					// fall through to default
				default :
					editormonkey::load_FCKeditor( 'comment', $em_height, $em_lang, $em_toolbar, $em_skin, $em_spellcheck, false );
					break;
			}
		}
	}
	
	
	/** 
		Loads the FCKeditor interface
	*/
	function load_FCKeditor ( $em_textarea, $em_height, $em_lang, $em_toolbar, $em_skin, $em_spellcheck, $em_upload ) {
	if (($em_spellcheck == 'Jacuba') || ($em_spellcheck == 'phpSpell')) {$em_spellcheck='';}
?>
<script type="text/javascript">
// Doesn't wait until loading b/c sometimes Firefox doesn't ever finish loading the page.
// Instead...we wait for the image below this to load	
function initFCK() {
	var oFCKeditor = new FCKeditor( '<?php echo $em_textarea; ?>' ) ;
	oFCKeditor.Config["CustomConfigurationsPath"] = "<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/emfckconfig.js.php"  ;
	
	// Basic stuff
	oFCKeditor.BasePath = "<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/fckeditor/";
	oFCKeditor.Config[ "BaseHref"] = "<?php echo get_settings('siteurl'); ?>" ;
	oFCKeditor.Height = "<?php echo $em_height; ?>";
	
	// Interface
	oFCKeditor.ToolbarSet = "<?php echo $em_toolbar; ?>";
	oFCKeditor.Config[ "SkinPath"] = oFCKeditor.BasePath + 'editor/skins/<?php echo $em_skin; ?>/';
	
	// Language and spellchecking
	oFCKeditor.Config[ "DefaultLanguage" ] = "<?php echo $em_lang; ?>";
	oFCKeditor.Config[ "SpellChecker" ] = "<?php echo $em_spellcheck; ?>";
	
	// Uploads 
	<?php if ($em_textarea == 'comment') { ?>
	oFCKeditor.Config.LinkBrowser = false;
	oFCKeditor.Config.ImageBrowser = false;
	oFCKeditor.Config.FlashBrowser = false;
	<?php } ?>
	
	oFCKeditor.ReplaceTextarea() ;
}
</script>
<img src="<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/spacer.gif" onload="initFCK();" />
<?php
	}
	
	
	/** 
		Loads the TinyMCE interface
	*/
	function load_TinyMCE ( $em_textarea, $em_height, $em_lang, $em_toolbar, $em_spellcheck, $em_upload ) {	
		// Convert Spell Check variable...
		switch ($em_spellcheck) {
		case 'SpellerPages' :
			$em_spellcheck='spellerpages'; break;
		case 'ieSpell' : 
			$em_spellcheck='iespell'; break;
		case 'Jacuba' :
			$em_spellcheck='jacuba'; break;
		default :
			$em_spellcheck='';
		}
				
		// Load the plugins we need, only load one of the spell check plugins
			// WP filters hook for the rich editor plugins
			$wp_mce_plugins = apply_filters('mce_plugins', array());
		$plugins = get_option('editormonkey_mce_plugins');
		if (NULL !== $plugins) {
			$em_plugins = "'";
			$num_plugins = count($plugins);
			for ( $i = 0; ($i < $num_plugins) && is_array($plugins); $i++ ) {
				$plugin = array_pop($plugins);
				if ($plugin == 'spellcheck') {
					$plugin = $em_spellcheck;
				} 
				$em_plugins = $em_plugins . "$plugin,";
			}
			$em_plugins = $em_plugins . implode($wp_mce_plugins, ',');
			$em_plugins = $em_plugins . "'";
		} else {
			$em_plugins = "'" . implode($wp_mce_plugins, ',') . "'";
		}
		
		// Load Toolbars here so we don't clutter the javascript output...plus do WP plugin stuff
		if ($em_textarea == 'comment') { 
			$mce_buttons = ''; 
		} else {
			// Run the WP filters for the rich editor toolbar buttons
			$mce_buttons = apply_filters('mce_buttons', array());
			$mce_buttons_2 = apply_filters('mce_buttons_2', array());
			$mce_buttons_3 = apply_filters('mce_buttons_3', array());
			// Implode them up nicely into a single variable
			$mce_buttons = implode($mce_buttons, ',');
			$mce_buttons = $mce_buttons . implode($mce_buttons_2, ',');
			$mce_buttons = $mce_buttons . implode($mce_buttons_3, ',');
		}

		switch ($em_toolbar) {
			case 'WordPress': 
				$em_toolbar = 'WordPress1,WordPress2,WordPress3';
				$em_toolbar_content = "theme_advanced_container_WordPress1 : 'undo,redo,separator,selectall,cut,copy,paste,separator,pastetext,pasteword,separator,search,replace,separator,code, cleanup,separator,visualaid,fullscreen,separator,help,$em_spellcheck',\n" .
	"\ttheme_advanced_container_WordPress2 : 'link,unlink,anchor,separator,image,flash,separator,more,nextpage,separator,advhr,charmap,emotions,$mce_buttons',\n" .
	"\ttheme_advanced_container_WordPress3 : 'formatselect,separator,fontsizeselect,separator,bold,italic,underline,strikethrough,sub,sup,separator,justifyleft,justifyright,justifycenter,justifyfull,separator,bullist,numlist,indent,outdent,separator,forecolor,backcolor,separator,removeformat',";
				break;
			case 'Simple' :
				$em_toolbar_content = "theme_advanced_container_Simple : 'bold,italic,underline,separator,fontsizeselect,forecolor,numlist,bullist,separator,link,unlink,separator,image,emotions,separator,undo,redo,$em_spellcheck,$mce_buttons',";
				break;
			case 'Comments' :
				$em_toolbar_content = "theme_advanced_container_Comments :  'bold,italic,underline,separator,numlist,bullist,separator,emotions,separator,undo,redo,$em_spellcheck,$mce_buttons',";
				break;
			case 'Basic' :
				$em_toolbar_content = "theme_advanced_container_Basic : 'bold,italic,underline,separator,numlist,bullist,separator,link,unlink,separator,emotions,separator,undo,redo,$em_spellcheck,$mce_buttons',";
			default:
				$em_toolbar = get_option('editormonkey_mce_toolbars');
				$selected_toolbars = explode(',',$em_toolbar);
				$toolbars_data = get_option('editormonkey_mce_toolbars_data');
				for ($i=0; $i<count($selected_toolbars); $i++) {
					if ($selected_toolbars[$i]) {
						$tbname = $selected_toolbars[$i];
						$tbcontent = $toolbars_data[$tbname];
						$em_toolbar_content = $em_toolbar_content . "theme_advanced_container_$tbname : '$tbcontent',";
					}
				}
				break;
		}
		
		// Go through the toolbar contents and replace the EM editor placeholders - spellcheck, mcebuttons (v2.5???)
		$em_toolbar_content = str_replace('spellcheck',$em_spellcheck,$em_toolbar_content);
		$em_toolbar_content = str_replace('mcebuttons',$mce_buttons,$em_toolbar_content);
		
		// Comment form overrides
		if ( $em_textarea == 'comment' ) {
			$em_resize = 'false';
		}
		// resize
		// upload
?>
<style type="text/css">
.wpTinyMCE a { border-bottom:none;}
</style>
<script language="javascript" type="text/javascript">
// Check for preview window (true/false determined by php code)
if ( window == top || <?php echo get_option('editormonkey_interface')!='tinymce' ? 'true' : 'false';?>) {
	<?php 
		// Not for the faint of heart, but here for WP plugins that use it
		do_action('tinymce_before_init'); 
	?>
tinyMCE.init({
	mode : "exact",
	elements : "<?php echo $em_textarea; ?>",
	language : "<?php echo $em_lang; ?>",
	height: "<?php echo $em_height; ?>",
	
	relative_urls : false, // relative url's don't work to well in tinymce using firefox
	remove_script_host : false,
	force_p_newlines : true,
	force_br_newlines : false,
	convert_newlines_to_brs : false,
	remove_linebreaks : true,
	
	plugins : <?php echo $em_plugins; ?>,
	<?php if ($em_upload == 'true') echo 'file_browser_callback : "fileBrowserCallBack",'; ?>

	theme : "advanced",
	theme_advanced_layout_manager : "RowLayout",
	theme_advanced_containers_default_class : "wpTinyMCE",
	theme_advanced_containers_default_align : "left",
	theme_advanced_resizing : <?php echo get_option('editormonkey_mce_resize'); ?>,	
	
	theme_advanced_containers : "<?php echo $em_toolbar; ?>,mceEditor<?php echo ($em_textarea != 'comment') ? ',mceElementpath' : ''; ?>",
	<?php echo $em_toolbar_content; ?>
	
	<?php 
		// Here only for other WP plugins that may use this action hook
		do_action('mce_options');
	?>
	
	<?php
	if (get_option('editormonkey_mce_extended') == 'true') {
		$valid_elements = get_option('editormonkey_mce_valid_elements');
		$valid_elements = str_replace("\n",'',$valid_elements);
		$valid_elements = str_replace("\r",'',$valid_elements);
	} else {
		$valid_elements = '-a[id|href|title|rel|target],-strong/b,-em/i,-strike,-del,-u,font[face|color],p[class|align|dir],-ol,-ul,-li,br,img[class|src|alt|title|width|height|align],-sub,-sup,-blockquote[dir],-table[border|cellspacing|cellpadding|width|height|class|align|dir],tr[class|rowspan|width|height|align|valign|dir],td[dir|class|colspan|rowspan|width|height|align|valign],-div[dir|class|align],-span[class|align],-pre[class],-code[class],-address,-h1[class|align|dir],-h2[class|align|dir],-h3[class|align|dir],-h4[class|align|dir],-h5[class|align|dir],-h6[class|align|dir],hr[class|width|size|noshade]';
	}
	$valid_elements = apply_filters('mce_valid_elements', $valid_elements);
	echo 'valid_elements: "' . $valid_elements . '"';

	// additional custom parameters with which to initialize TinyMCE
	$additional_params = trim(stripslashes(get_option('editormonkey_mce_addparams')));
	if ($additional_params)
		echo ",\n $additional_params";
	
	// TinyMCE Appearance
	$css_base_url = get_settings('siteurl') . '/wp-content/plugins/editormonkey';
				
		// Editing Area style
		if (trim(stripslashes(get_option('editormonkey_custom_styles'))))
			$css_styles = $css_base_url . '/custom_styles.php';
		if ('true' == get_option('editormonkey_mce_css_content')) 
			$css_editor = $css_base_url . '/mce_editor_content.css';
		echo ",\n content_css : '$css_styles,$css_editor'";
			
			
		// Editing UI style
		$use_custom_editor_ui = get_option('editormonkey_mce_css_editor');
		if ('true' == $use_custom_editor_ui)
			echo ",\n editor_css : '$css_base_url/mce_editor_ui.css'";
	?>
	
});}

	function fileBrowserCallBack(field_name, url, type, win) {
			tinyfck_field = field_name;
			tinyfck = win;
			window.open("<?php echo get_settings('siteurl'); ?>/wp-content/plugins/editormonkey/tinymce/filemanager/browser.html?Connector=connectors/em/connector.php<?php global $post_ID; echo '&PostID='.$post_ID; ?>", "tinyfck", "modal,width=600,height=400");
	}
</script>
<?php
	}
	
	
	/** 
		Displays the EditorMonkey configuration form
	*/
	function plugin_panel () {
		$path = get_option('siteurl') . '/wp-admin/admin.php?page=editormonkey.php'; // Form Action URI
		include ('editormonkey'.DIRECTORY_SEPARATOR.'helpers.inc.php');	
		include ('editormonkey'.DIRECTORY_SEPARATOR.'options.inc.php');
	}
	
	
	/** 
		Adds EditorMonkey to the Personal Options section of the (user) Profile page
	*/
	function user_personalopts() {
		global $current_user;
		
		// Update personal dictionary, since doing so in updates doesn't work if query delayed
		editormonkey::create_dictionary( $current_user->id );
		
		include ('editormonkey'.DIRECTORY_SEPARATOR.'helpers.inc.php');	
		include ('editormonkey'.DIRECTORY_SEPARATOR.'profile.inc.php');
	}
	
	
	/** 
		Updates EditorMonkey user settings set from the Profile page
	*/
	function user_personalopts_update() {
		global $current_user;
		
		if ( !isset( $_POST['em_use'] ) ) {
			$_POST['em_use'] = 'false';
		} else {
			update_user_option( $current_user->id, 'rich_editing', 'false', true );
		}
			
		update_user_option( $current_user->id, 'em_user_userprefset', 'true', true );
		
		// Shared settings
		update_user_option( $current_user->id, 'em_user_use', $_POST['em_use'], true);

		update_user_option( $current_user->id, 'em_user_interface', $_POST['em_interface'], true);
		update_user_option( $current_user->id, 'em_user_height', htmlspecialchars($_POST['em_height']), true);
		update_user_option( $current_user->id, 'em_user_lang', htmlspecialchars($_POST['em_lang']), true);
		
		// FCK settings
		update_user_option( $current_user->id, 'em_user_toolbar', $_POST['em_fck_toolbar'], true);
		update_user_option( $current_user->id, 'em_user_fck_skin', $_POST['em_fck_skin'], true);
		
		// TinyMCE settings
		
		// Spell Checking
		update_user_option( $current_user->id, 'em_user_spell_words', htmlspecialchars($_POST['em_spellwords']), true);
	}
}

} // class exists

	
if ( !function_exists('em_set_perms') ) {
	function em_set_perms ($path) {
		if ( substr($path, strlen($path)-1) != DIRECTORY_SEPARATOR ) { $path .= DIRECTORY_SEPARATOR; } 
		
		if ($handle = opendir($path)) {
			$files = array();
			while ( false !== ($file = readdir($handle)) ) {
				if ( $file != '.' && $file != '..') {
					$file = $path . $file;
					if ( is_dir($file) ) {
						// chmod
						$oldumask = umask(0) ;
						chmod($file, 0755);
						umask( $oldumask ) ;
						// recursive!
						$files[] = $file;
					}
				}
			}
			closedir($handle);
			foreach ($files as $dir) {
				em_set_perms($dir);
			}
		}
	}
}
		
		
// Create monkey object to get the ball rolling, but only if compatibility version not loaded
if (!function_exists('editormonkey'))
	$editor_monkey = new editormonkey();

?>