<?php
/* Checks settings and stuff for EM to aid with debugging and troubleshooting. */
/*
	Required:
		EditorMonkey base directory - 755 - read (all), write (owner), list (all)
		TinyMCE base directory - 755 - read (all), write (owner), list (all)
		FCKeditor base directory - 755 - read (all), write (owner), list (all)
		Upload directory - 755 - read (all), write (owner), list (all)
*/

include_once ('../../../wp-config.php');
include_once ('../editormonkey.php');

// CHECK FOR ADMINS...

// Actions...
switch($_GET['action']) {
}
?> 

<style type="text/css">
	.good {
		color:#00dd00;
	}
	.notpreferred {
		color:#bbbb33;
	}
	.bad {
		color:#FF0000;
	}
</style>

<h2>Server and PHP settings: </h2>
<table>

	<tr>
		<td><b>PHP Version:</b></td>
		<td>
		<?php 
			if (strstr(PHP_VERSION,'5.')||strstr(PHP_VERSION,'4.4')) {
				echo '<span class="good">'.PHP_VERSION.'</span>'; 
			} else if (strstr(PHP_VERSION,'4.3')) {
				echo '<span class="notpreferred">'.PHP_VERSION.' - EditorMonkey does not work well in PHP 4.3.x. You should use the EditorMonkey compatibility version (editormonkey-compat.php).</span>'; 
			} else {
				echo '<span class="bad">'.PHP_VERSION.' - EditorMonkey only works in PHP 4.3+.</span>'; 
			}
		?>
		</td>
	</tr>
	<tr>
		<td><b>WordPress Version:</b></td>
		<td><?php global $wp_version; echo strstr($wp_version,'2.0') ? "<span class='good'>$wp_version</span>" : "<span class='bad'>$wp_version - EditorMonkey only works in WordPress 2.0+.</span>"; ?>
		</td>
	</tr>
	<tr>
		<td><b>EditorMonkey Version:</b></td>
		<td><?php echo "<span class='good'>$editormmonkey_version</span>"; ?>
		</td>
	</tr>
	<tr>
		<td><b>Safe Mode:</b></td>
		<td>
		<?php 
			if (!ini_get('safe_mode')||ini_get('safe_mode')!='Off') {
				echo '<span class="good">Off</span>'; 
			} else {
				echo ini_get('safe_mode').'<span class="bad">On. EditorMonkey does not work well in PHP Safe Mode. You should use the EditorMonkey compatibility version (editormonkey-compat.php).</span>'; 
			}
		?>
		</td>
	</tr>
	<tr>
		<td><b>File Uploads Allowed:</b></td>
		<td><?php echo ini_get('file_uploads') ? '<span class="good">Yes</span>' : '<span class="bad">No</span>'; ?>
		</td>
	</tr>
	<tr>
		<td><b>Maximum Upload Size:</b></td>
		<td><?php echo ini_get('post_max_size');?></td>
	</tr>
	<tr>
		<td><b>Disabled Functions:</b></td>
		<td>
		<?php 
			$disabledfuncs = ini_get('disable_functions');
			echo str_replace('shell_exec','<span class="bad">shell_exec</span>',$disabledfuncs);
			if (strstr($disabledfuncs,'shell_exec')) {
				echo '<br/><span class="bad">Shell_exec must be enabled to use SpellerPages/aspell.</span>';
			}
		?>
		</td>
	</tr>
</table>


<h2>Directories: </h2>
<?php
	// Check all essential directory permissions
	$dir_em = substr(sprintf('%o', fileperms(dirname(__FILE__))), -4);
	$dir_mce = substr(sprintf('%o', fileperms(dirname(__FILE__).'/tinymce')), -4);
	$dir_fck = substr(sprintf('%o', fileperms(dirname(__FILE__).'/fckeditor')), -4);
	
	function directory_permissions($perms) {
		switch ($perms) {
			case '755':
				echo "<span class='good'>$perms</span>";
				break;
			case '766': case '767':
				echo "<span class='bad'>$perms<br>The (file or directory)'s contents cannot be listed by the group or by the apache user. You should use 755 (owner: all; group/everyone: read,execute.</span>";
				break;
			case '777':  case '776': case '775':
				echo "<span class='notpreferred'>$perms<br>The (file or directory)'s permissions are too broad. This is not safe. You should use 755 (owner: all; group/everyone: read,execute.</span>";
				break;
			default:
				echo "<span class='bad'>$perms<br>The (file or directory)'s permissions must be set to 755.</span>";
				break;
		}
	}
?>
<table width="100%">
	<tr>
		<td colspan="3"><b>EditorMonkey</b></td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2">Try to set proper permissions for the EditorMonkey directory...</td>
	</tr>
	<tr>
		<td width="15"></td>
		<td valign="top"><em>editormonkey/</em></td>
		<td><?php directory_permissions($dir_em); ?></td>
	</tr>
	<tr>
		<td colspan="3"><b>TinyMCE</b></td>
	</tr>
	<tr>
		<td></td>
		<td valign="top"><em>editormonkey/tinymce/</em></td>
		<td><?php directory_permissions($dir_mce); ?></td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2">Try to set proper permissions for all TinyMCE files and directories...</td>
	</tr>
	<tr>
		<td colspan="2"><b>FCKEditor</b></td>
	</tr>
	<tr>
		<td></td>
		<td valign="top"><em>editormonkey/fckeditor/</em></td>
		<td><?php directory_permissions($dir_fck); ?></td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2">Try to set proper permissions for all FCKeditor files and directories...</td>
	</tr>
	<tr>
		<td colspan="2"><b>Upload directories</b></td>
	</tr>
	<tr>
		<td></td>
		<td>Check that all the directories exist and 777</td>
		<td></td>
	</tr>
	<tr>
		<td></td>
		<td colspan="2">Try to create and/or set proper permissions for all Upload directories</td>
	</tr>
</table>