/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('jacuba', 'en'); // <- Add a comma separated list of all supported languages

// Plugin static class
var TinyMCE_JacubaPlugin = {
	getInfo : function() {
		return {
			longname : 'Jacuba Spell Checker',
			author : 'Jacuba, Raj Prasad',
			authorurl : 'http://www.rajprasad.net/',
			infourl : 'http://www.jacuba.com/',
			version : tinyMCE.majorVersion + "." + tinyMCE.minorVersion
		};
	},


	/**
	 * Returns the HTML contents of the emotions control.
	 */
	getControlHTML : function(cn) {
		switch (cn) {
			case "jacuba":
				return tinyMCE.getButtonHTML(cn, 'lang_jacuba_desc', '{$pluginurl}/images/spellcheck.gif', 'mceJacuba');
		}

		return "";
	},
				

	/**
	 * Executes the WordPress plugin commands.
	 */
	execCommand : function(editor_id, element, command, user_interface, value) {
		var instance = tinyMCE.getInstanceById(editor_id);
		var focusElm = instance.getFocusElement();
		var doc = instance.getDoc();
		var flag = "";
		
		var ie4 = (document.all) ? 1:0;
		var gecko=(navigator.userAgent.indexOf('Gecko') > -1) ? 1:0;
		var sf=(navigator.userAgent.indexOf('Safari') > -1) ? 1:0;
		if (sf) { ie4 = 0; gecko = 1; }
		
		
		switch (command) {
			case "mceJacuba":
				instance.formElement.value ='WORK';
				tinyMCE.triggerSave(false,false);                      

				// Creates the jacuba window which does all the dirty work.
				height = 380; 
				width = 500;
		
				if (ie4) { height = height + 20; }
		
				if (!(gecko || ie4)) {
					alert("jacuba only supports one of the following browsers:\nMozilla 1+, Internet Explorer 4+");
				} else {
					var template = new Array();
		
					template['file'] = '../../plugins/jacuba/jacuba.html'; // Relative to theme
					template['width'] = width;
					template['height'] = height;
					
					tinyMCE.openWindow(template, {editor_id : editor_id, inline : "yes"});
					return true;
				}
		}
		
		// Pass to next handler in chain
		return false;
	}	
};

// Register plugin
tinyMCE.addPlugin('jacuba', TinyMCE_JacubaPlugin);